/* Problem URL: https://codeforces.com/edu/course/2/lesson/4/4/practice/contest/274684/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, q;
    cin >> n >> q;

    vl fds(n);
    cin >> fds;

    while (__builtin_popcount(n) != 1) {
        n++;
        fds.push_back(40);
    }

    using vet = array<ll, 40>;

    V<vet> seg(n * 2);

    auto mergeseg = [&](vet &a, vet &b, vet &ans) {
        for (int i = 39; i >= 0; i--) {
            ans[i] = b[i] | a[i];
        }
    };

    nrep(i, n, n * 2) {
        seg[i].fill(0);
        seg[i][fds[i - n] - 1] = 1;
    }

    for (int i = n - 1; i > 0; i--) {
        mergeseg(seg[i * 2], seg[i * 2 + 1], seg[i]);
    }

    auto update = [&](int i, ll v) {
        i += n;
        seg[i][fds[i - n] - 1] = 0;
        seg[i][v - 1] = 1;
        fds[i - n] = v;

        for (i >>= 1; i > 0; i >>= 1) {
            mergeseg(seg[i * 2], seg[i * 2 + 1], seg[i]);
        }
    };

    const vet empty = {0};

    function<void(int, int, int, int, int, vet&)> query = [&](int i, int l, int r, int tl, int tr, vet &ans) {
        if (l > tr || r < tl) {
            ans = empty;
            return;
        }

        if (l >= tl && r <= tr) {
            ans = seg[i];
            return;
        }

        vet ans1;
        vet ans2;

        int mid = (l + r) >> 1;

        query(i * 2, l, mid, tl, tr, ans1);
        query(i * 2 + 1, mid + 1, r, tl, tr, ans2);
        mergeseg(ans1, ans2, ans);
    };

    while (q--) {
        int op, x, y;
        cin >> op >> x >> y;

        if (op == 1) {
            vet ans;
            query(1, 0, n - 1, x - 1, y - 1, ans);

            int count = 0;
            rep(i, 40) {
                count += ans[i];
            }

            cout << count << '\n';
            continue;
        }

        update(x - 1, y);
    }
}
